import * as plugins from '../cloudly.plugins.js';
import type { ImageManager } from './classes.imagemanager.js';

@plugins.smartdata.Manager()
export class Image extends plugins.smartdata.SmartDataDbDoc<Image, plugins.servezoneInterfaces.data.IImage, ImageManager> {
  public static async create(imageDataArg: Partial<plugins.servezoneInterfaces.data.IImage['data']>) {
    const image = new Image();
    image.id = plugins.smartunique.uni('image');
    Object.assign(image.data, imageDataArg);
    await image.save();
    return image;
  }

  @plugins.smartdata.unI()
  public id: string;

  @plugins.smartdata.svDb()
  public data: plugins.servezoneInterfaces.data.IImage['data'];

  public async getVersions() {}
}