import * as plugins from '../../plugins.js';

import {
  customElement,
  html,
  DeesElement,
  property,
  type TemplateResult,
  cssManager,
  css,
  unsafeCSS,
  type CSSResult,
  state,
} from '@design.estate/dees-element';

@customElement('cloudly-sectionheading')
export class CloudlySectionheading extends DeesElement {
  public static styles = [
    cssManager.defaultStyles,
    css`
      h1 {
        font-family: 'Cal Sans';
        letter-spacing: 0.025em;
      }
    `,
  ]

  public render() {
    return html`
      <h1><slot></slot></h1>
    `;
  }
}